Index: /trunk/src/VBox/Runtime/r3/alloc-ef.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/alloc-ef.cpp	(revision 28272)
+++ /trunk/src/VBox/Runtime/r3/alloc-ef.cpp	(revision 28273)
@@ -323,5 +323,5 @@
          * and then change the page protection of the fence.
          */
-        #ifdef RTALLOC_EFENCE_IN_FRONT
+#ifdef RTALLOC_EFENCE_IN_FRONT
         void *pvEFence = pvBlock;
         void *pv = (char *)pvEFence + RTALLOC_EFENCE_SIZE;
@@ -329,5 +329,5 @@
         memset((char *)pv + cb, RTALLOC_EFENCE_NOMAN_FILLER, cbBlock - RTALLOC_EFENCE_SIZE - cb);
 # endif
-        #else
+#else
         void *pvEFence = (char *)pvBlock + (cbBlock - RTALLOC_EFENCE_SIZE);
         void *pv = (char *)pvEFence - cbAligned;
@@ -336,5 +336,5 @@
         memset((char *)pv + cb, RTALLOC_EFENCE_NOMAN_FILLER, cbAligned - cb);
 # endif
-        #endif
+#endif
 
 #ifdef RTALLOC_EFENCE_FENCE_FILLER
@@ -344,7 +344,7 @@
         if (!rc)
         {
-            #ifdef RTALLOC_EFENCE_TRACE
+#ifdef RTALLOC_EFENCE_TRACE
             rtmemBlockInsert(pBlock, pv);
-            #endif
+#endif
             if (enmType == RTMEMTYPE_RTMEMALLOCZ)
                 memset(pv, 0, cb);
@@ -398,13 +398,13 @@
             RTLogPrintf("RTMem %s: pv=%p pvCaller=%p cb=%#x\n", pszOp, pv, pvCaller, pBlock->cb);
 
-#ifdef RTALLOC_EFENCE_NOMAN_FILLER
+# ifdef RTALLOC_EFENCE_NOMAN_FILLER
         /*
          * Check whether the no man's land is untouched.
          */
-# ifdef RTALLOC_EFENCE_IN_FRONT
+#  ifdef RTALLOC_EFENCE_IN_FRONT
         void *pvWrong = ASMMemIsAll8((char *)pv + pBlock->cb,
                                      RT_ALIGN_Z(pBlock->cb, PAGE_SIZE) - pBlock->cb,
                                      RTALLOC_EFENCE_NOMAN_FILLER);
-# else
+#  else
         /* Alignment must match allocation alignment in rtMemAlloc(). */
         size_t cbAligned = RT_ALIGN_Z(pBlock->cb, RTALLOC_EFENCE_ALIGNMENT);
@@ -417,17 +417,17 @@
                                RT_ALIGN_Z(cbAligned, PAGE_SIZE) - cbAligned,
                                RTALLOC_EFENCE_NOMAN_FILLER);
-# endif
+#  endif
         if (pvWrong)
             RTAssertDoPanic();
-#endif
-
-    #ifdef RTALLOC_EFENCE_FREE_FILL
+# endif
+
+# ifdef RTALLOC_EFENCE_FREE_FILL
         /*
          * Fill the user part of the block.
          */
         memset(pv, RTALLOC_EFENCE_FREE_FILL, pBlock->cb);
-    #endif
-
-    #if defined(RTALLOC_EFENCE_FREE_DELAYED) && RTALLOC_EFENCE_FREE_DELAYED > 0
+# endif
+
+# if defined(RTALLOC_EFENCE_FREE_DELAYED) && RTALLOC_EFENCE_FREE_DELAYED > 0
         /*
          * We're doing delayed freeing.
@@ -444,9 +444,9 @@
             {
                 pv = pBlock->Core.Key;
-                #ifdef RTALLOC_EFENCE_IN_FRONT
+#  ifdef RTALLOC_EFENCE_IN_FRONT
                 void *pvBlock = (char *)pv - RTALLOC_EFENCE_SIZE;
-                #else
+#  else
                 void *pvBlock = (void *)((uintptr_t)pv & ~PAGE_OFFSET_MASK);
-                #endif
+#  endif
                 size_t cbBlock = RT_ALIGN_Z(pBlock->cb, PAGE_SIZE) + RTALLOC_EFENCE_SIZE;
                 rc = RTMemProtect(pvBlock, cbBlock, RTMEM_PROT_READ | RTMEM_PROT_WRITE);
@@ -461,16 +461,16 @@
             rtmemComplain(pszOp, "Failed to expand the efence of pv=%p cb=%d, rc=%d.\n", pv, pBlock, rc);
 
-    #else /* !RTALLOC_EFENCE_FREE_DELAYED */
+# else /* !RTALLOC_EFENCE_FREE_DELAYED */
 
         /*
          * Turn of the E-fence and free it.
          */
-        #ifdef RTALLOC_EFENCE_IN_FRONT
+#  ifdef RTALLOC_EFENCE_IN_FRONT
         void *pvBlock = (char *)pv - RTALLOC_EFENCE_SIZE;
         void *pvEFence = pvBlock;
-        #else
+#  else
         void *pvBlock = (void *)((uintptr_t)pv & ~PAGE_OFFSET_MASK);
         void *pvEFence = (char *)pv + pBlock->cb;
-        #endif
+#  endif
         int rc = RTMemProtect(pvEFence, RTALLOC_EFENCE_SIZE, RTMEM_PROT_READ | RTMEM_PROT_WRITE);
         if (RT_SUCCESS(rc))
@@ -480,5 +480,5 @@
         rtmemBlockFree(pBlock);
 
-    #endif /* !RTALLOC_EFENCE_FREE_DELAYED */
+# endif /* !RTALLOC_EFENCE_FREE_DELAYED */
     }
     else