Index: /trunk/src/VBox/Devices/Network/DrvNAT.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/DrvNAT.cpp	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/DrvNAT.cpp	(revision 28365)
@@ -1181,13 +1181,9 @@
                                    pDrvIns->iInstance, szNetwork);
 
-    char szNetAddr[16];
-    RTStrPrintf(szNetAddr, sizeof(szNetAddr), "%d.%d.%d.%d",
-               (Network & 0xFF000000) >> 24, (Network & 0xFF0000) >> 16,
-               (Network & 0xFF00) >> 8, Network & 0xFF);
-
     /*
      * Initialize slirp.
      */
-    rc = slirp_init(&pThis->pNATState, &szNetAddr[0], Netmask, fPassDomain, !!fUseHostResolver, pThis);
+    rc = slirp_init(&pThis->pNATState, RT_H2N_U32(Network), Netmask,
+                    fPassDomain, !!fUseHostResolver, pThis);
     if (RT_SUCCESS(rc))
     {
Index: /trunk/src/VBox/Devices/Network/slirp/bootp.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/bootp.c	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/slirp/bootp.c	(revision 28365)
@@ -272,5 +272,5 @@
     FILL_BOOTP_EXT(q, RFC1533_GATEWAY, 4, &saddr);
 
-    if (pData->use_dns_proxy || pData->use_host_resolver)
+    if (pData->fUseDnsProxy || pData->fUseHostResolver)
     {
         uint32_t addr = RT_H2N_U32(RT_N2H_U32(pData->special_addr.s_addr) | CTL_DNS);
@@ -300,5 +300,5 @@
             FILL_BOOTP_EXT(q, RFC1533_DOMAINNAME, 1, " ");
     }
-    if (pData->fPassDomain && !pData->use_host_resolver)
+    if (pData->fPassDomain && !pData->fUseHostResolver)
     {
         LIST_FOREACH(dd, &pData->pDomainList, dd_list)
Index: /trunk/src/VBox/Devices/Network/slirp/libslirp.h
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/libslirp.h	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/slirp/libslirp.h	(revision 28365)
@@ -29,9 +29,5 @@
 #endif
 
-#ifndef VBOX_WITH_NAT_SERVICE
-int slirp_init(PNATState *, const char *, uint32_t, bool, bool, void *);
-#else
 int slirp_init(PNATState *, uint32_t, uint32_t, bool, bool, void *);
-#endif
 void slirp_register_statistics(PNATState pData, PPDMDRVINS pDrvIns);
 void slirp_deregister_statistics(PNATState pData, PPDMDRVINS pDrvIns);
Index: /trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 28365)
@@ -523,11 +523,6 @@
 }
 
-#ifndef VBOX_WITH_NAT_SERVICE
-int slirp_init(PNATState *ppData, const char *pszNetAddr, uint32_t u32Netmask,
-               bool fPassDomain, bool fUseHostResolver, void *pvUser)
-#else
 int slirp_init(PNATState *ppData, uint32_t u32NetAddr, uint32_t u32Netmask,
                bool fPassDomain, bool fUseHostResolver, void *pvUser)
-#endif
 {
     int fNATfailed = 0;
@@ -541,5 +536,5 @@
         return VERR_INVALID_PARAMETER;
     pData->fPassDomain = !fUseHostResolver ? fPassDomain : false;
-    pData->use_host_resolver = fUseHostResolver;
+    pData->fUseHostResolver = fUseHostResolver;
     pData->pvUser = pvUser;
     pData->netmask = u32Netmask;
@@ -585,9 +580,5 @@
 #endif
 
-#ifndef VBOX_WITH_NAT_SERVICE
-    inet_aton(pszNetAddr, &pData->special_addr);
-#else
     pData->special_addr.s_addr = u32NetAddr;
-#endif
     pData->slirp_ethaddr = &special_ethaddr[0];
     alias_addr.s_addr = pData->special_addr.s_addr | RT_H2N_U32_C(CTL_ALIAS);
@@ -596,5 +587,5 @@
     /* set default addresses */
     inet_aton("127.0.0.1", &loopback_addr);
-    if (!pData->use_host_resolver)
+    if (!pData->fUseHostResolver)
     {
         if (slirp_init_dns_list(pData) < 0)
@@ -625,5 +616,5 @@
         ftp_alias_load(pData);
         nbt_alias_load(pData);
-        if (pData->use_host_resolver)
+        if (pData->fUseHostResolver)
             dns_alias_load(pData);
     }
@@ -729,5 +720,5 @@
     ftp_alias_unload(pData);
     nbt_alias_unload(pData);
-    if (pData->use_host_resolver)
+    if (pData->fUseHostResolver)
         dns_alias_unload(pData);
     while (!LIST_EMPTY(&instancehead))
@@ -1915,8 +1906,8 @@
 void slirp_set_dhcp_dns_proxy(PNATState pData, bool fDNSProxy)
 {
-    if (!pData->use_host_resolver)
+    if (!pData->fUseHostResolver)
     {
         Log2(("NAT: DNS proxy switched %s\n", (fDNSProxy ? "on" : "off")));
-        pData->use_dns_proxy = fDNSProxy;
+        pData->fUseDnsProxy = fDNSProxy;
     }
     else
Index: /trunk/src/VBox/Devices/Network/slirp/slirp_state.h
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 28365)
@@ -281,5 +281,5 @@
     uma_zone_t zone_ext_refcnt;
 #endif
-    int use_host_resolver;
+    bool fUseHostResolver;
     /* from dnsproxy/dnsproxy.h*/
     unsigned int authoritative_port;
@@ -311,5 +311,5 @@
     struct request *request_hash[1 << HASHSIZE];
     /* this field control behaviour of DHCP server */
-    bool use_dns_proxy;
+    bool fUseDnsProxy;
 
     LIST_HEAD(RT_NOTHING, libalias) instancehead;
Index: /trunk/src/VBox/Devices/Network/slirp/udp.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 28364)
+++ /trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 28365)
@@ -162,5 +162,5 @@
     }
 
-    if (   pData->use_host_resolver
+    if (   pData->fUseHostResolver
         && uh->uh_dport == RT_H2N_U16_C(53)
         && CTL_CHECK(RT_N2H_U32(ip->ip_dst.s_addr), CTL_DNS))
@@ -256,5 +256,5 @@
      * DNS proxy
      */
-    if (   pData->use_dns_proxy
+    if (   pData->fUseDnsProxy
         && (ip->ip_dst.s_addr == RT_H2N_U32(RT_N2H_U32(pData->special_addr.s_addr) | CTL_DNS))
         && (uh->uh_dport == RT_H2N_U16_C(53)))